/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2009
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */


#include <iostream>
#include <Yayi/core/yayiCommon/common_errors.hpp>
#include <Yayi/core/yayiCommon/include/common_types_T.hpp>

#ifndef NDEBUG
// demangle GCC
#include <cxxabi.h>
#endif

namespace yayi
{




	namespace errors
	{

		static std::ostream* yayi_error_stream_current = &std::cout;

		std::ostream& yayi_error_stream()
		{
			return *yayi_error_stream_current;
		}
    
    #ifndef NDEBUG
    std::string demangle(const char* name)
    {
      // need to demangle C++ symbols
      std::size_t len; 
      int         stat;
      char* realname = __cxxabiv1::__cxa_demangle(name,NULL,&len,&stat);
      
      if (realname != NULL)
      {
        std::string out(realname);
        std::free(realname);
        return out;
      }
      return name;
    }
    
    #if 0
    // on visual
    extern "C" char * _unDName(char * outputString, const char * name, int maxStringLength, void * (* pAlloc )(size_t), void (* pFree )(void *), unsigned short disableFlags);
    
    const char * const pName = <decorated name>;
    char * const pTmpUndName = _unDName(0, pName, 0, malloc, free, 0x2800);  
    if (pTmpUndName) 
    {
      std::string out(pTmpUndName);
      free(pTmpUndName);
      return out;
    }
    
    #endif
    
    #endif
		


	}
}


