/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2009
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */

#include <Yayi/core/yayiPixelProcessingPython/include/pixelprocessing_python.hpp>


#include <Yayi/core/yayiPixelProcessing/image_channels_process.hpp>
#include <Yayi/core/yayiPixelProcessing/image_color_process.hpp>


using namespace bpy;

void declare_channel_color() {

  def("CopyOneChannelIntoAnother",
    &yayi::CopyOneChannelIntoAnother,
    "(im_source, channel_input, channel_output, im_destination) : Copy the channel channel_input of the first image into the channel channel_output of the second image");

  def("CopyOneChannel",
    &yayi::CopyOneChannel,
    "(im_source, channel_input, im_destination) : Copy the channel channel_input of the first image into the second (scalar) image");




  def("RGB_to_HLS_l1",
    &yayi::RGB_to_HLS_l1,
    "(im_source, im_destination) : Transforms the colour space of the the RGB input image to HLS l1");
  def("RGB_to_HLS_l1",
    &yayi::HLS_l1_to_RGB,
    "(im_source, im_destination) : Transforms the colour space of the the HLS l1 input image to RGB");


}