/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2009
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */


#include <Yayi/core/yayiStructuringElement/yayiRuntimeStructuringElements_predefined.hpp>

namespace yayi { namespace se {
#define SE_FROM_TABLE(c, x) c::from_table_multiple(x, x + sizeof(x)/sizeof(x[0]))

  s_coordinate<2>::scalar_coordinate_type const coords_hexa2D[] = 
  {
    0,0, 1,0, -1,0, 0,1, 0,-1, 1,-1, 1,1,
    0,0, 1,0, -1,0, 0,1, 0,-1, -1,-1, -1,1
  };

  const s_neighborlist_se_hexa_x< s_coordinate<2> > SEHex2D(SE_FROM_TABLE(s_coordinate<2>, coords_hexa2D));


  s_coordinate<2>::scalar_coordinate_type const coords_sq2D[] = 
  {
    0,0, 
    1,0, -1,0, 
    0,1, 0,-1, 
    1,-1, 1,1, -1,1, -1,-1
  };
    
  const s_neighborlist_se< s_coordinate<2> > SESquare2D(SE_FROM_TABLE(s_coordinate<2>, coords_sq2D));

  s_coordinate<2>::scalar_coordinate_type const coords_sq3D[] = 
  {
    0,0,0,
    1,0,0, -1,0,0, 
    0,1,0, 0,-1,0,
    1,-1,0, 1,1,0, -1,1,0, -1,-1,0, 
    
    0,0,-1,
    1,0,-1, -1,0,-1, 
    0,1,-1, 0,-1,-1,
    1,-1,-1, 1,1,-1, -1,1,-1, -1,-1,-1, 
    
    0,0,1,
    1,0,1, -1,0,1, 
    0,1,1, 0,-1,1,
    1,-1,1, 1,1,1, -1,1,1, -1,-1,1 
  };
    
  const s_neighborlist_se< s_coordinate<3> > SESquare3D(SE_FROM_TABLE(s_coordinate<3>, coords_sq3D));

}}

