/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2009
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */


#include "main.hpp"
#include <Yayi/core/yayiLowLevelMorphology/lowlevel_erosion_dilation.hpp>
#include "Yayi/core/yayiIO/include/yayi_IO.hpp"
#include "Yayi/core/yayiImageCore/yayiImageCoreFunctions.hpp"
#include <iostream>
#include "Yayi/core/yayiStructuringElement/yayiRuntimeStructuringElements_predefined.hpp"

using namespace yayi;

void test_erosion() {
  std::cout << "Reading the image" << std::endl;
  
  std::string im_file_name("/Users/superraf/Pictures/Arg_NB_Cassis_IMG__025.png");
    
  IImage *im = 0;
  BOOST_REQUIRE(yayi::IO::readPNG(im_file_name, im) == yaRC_ok);
  IImage *imout = GetSameImage(im);
  BOOST_REQUIRE(imout != 0);
  yaRC res = llmm::erosion(im, &se::SESquare2D, imout);
  BOOST_CHECK(res != yaRC_ok);
  delete im; 
  delete imout;


}

void register_simple_operators_interface_tests(test_suite*& test) {
  test->add( BOOST_TEST_CASE( &test_erosion       ));
}